=== debian/changelog ===
guitarix (0.41.0+dfsg1-2~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * d/rules: disable dh_dwz to prevent FTBFS.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 03 Dec 2020 14:34:00 -0800

guitarix (0.41.0+dfsg1-2) unstable; urgency=medium

  * Team upload
  * Merge changes from 0.39.0+dfsg1-3.1 to fix build on i386

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 11 Aug 2020 21:33:01 +0200

guitarix (0.41.0+dfsg1-1) unstable; urgency=medium

  [ Dennis Braun ]
  * New upstream version 0.41.0
  * Build with gtk3 (Closes: #967506)
    + Update B-Ds
    + Remove gtk2 Depends from guitarix package
  * Add me as uploader
  * Update patchset
  * Update install files
  * Update documentation installation
  * Remove -Wl,--as-needed ldflags
  * Remove override_dh_missing since its default in dh 13

  [ Sebastian Ramacher ]
  * debian/copyright: Update paths

  [ Olivier Humbert ]
  * Update copyright years in d/copyright.

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 10 Aug 2020 18:26:43 +0200

guitarix (0.39.0+dfsg1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/rules: Added --disable-sse parameter to fix port baseline in i386.
    Thanks to Adrian Bunk <bunk@debian.org>. (Closes: #961380)

 -- Daniel Lenharo de Souza <lenharo@debian.org>  Wed, 10 Jun 2020 08:50:55 -0300

guitarix (0.39.0+dfsg1-3) unstable; urgency=medium

  * Fix LV2 types (Closes: #960250)
  * Fix spelling errors
  * Bump dh-compat to 13
  * Mark -dev packages as not Multi-Arch
  * Add archive and remove obsolete name field in d/upstream/metadata

 -- Dennis Braun <d_braun@kabelmail.de>  Thu, 21 May 2020 18:43:50 +0200
